#ifndef __FILEDIALOGWX30H__
#define __FILEDIALOGWX30H__


#include "wx/filedlg.h"


class FileDialog : public wxFileDialog
{
public: // constructors/destructors
    FileDialog() { }
    
    FileDialog(wxWindow *parent,
               const wxString& message = wxFileSelectorPromptStr,
               const wxString& defaultDir = wxEmptyString,
               const wxString& defaultFile = wxEmptyString,
               const wxString& wildCard = wxFileSelectorDefaultWildcardStr,
               long style = wxFD_DEFAULT_STYLE,
               const wxPoint& pos = wxDefaultPosition,
               const wxSize& sz = wxDefaultSize,
               const wxString& name = wxFileDialogNameStr);
    
    virtual ~FileDialog();
    
public: // public methods
    virtual void EnableButton(wxString label, fdCallback cb, void *cbdata);
    
    virtual void ClickButton(int index);
    
    virtual int ShowModal();
    
    void OnButton(wxCommandEvent& event);
    
private: // private methods
    static wxWindow * CreateButton(wxWindow *fileDialog);
    
private: // attributes
    wxString m_buttonlabel;
    
    fdCallback m_callback;
    
    void *m_cbdata;
};


#endif

